# -*- coding: utf-8 -*-
"""
Control function for MCS_052_main.py.

@author: Silvan Schwebke
"""

import numpy
import MCS_functions
import resistance

def MCS_job_full_hexagonal_varstrain(n,n_neighbors,ax,ay,az,d,sigma,hex_spacing,hex_angle,a,b,c,deformation_array,two_dimensions,visualize,E_ratio):
    """ (ungedehnte) Clusterverteilung erstellen """
    #random.seed(5)
    coordx, coordy, coordz, diameters, n_actual = MCS_functions.create_grid_hexagonal(n,ax,ay,az,d,sigma,hex_spacing,hex_angle)
    n = n_actual    
#    coordx, coordy, coordz, diameters = MCS_functions.create_grid(n,ax,ay,az,d,sigma)
    """ Next neighbor search, Widerstandsberechnung
        für ungedehnten Fall sowie longitudinal und transversal gedehnt """
    clusters_temp, dist_temp, newpoint1_temp, newpoint2_temp, tree_dist, tree_ind, temp0 = MCS_functions.MCS_find_neighbors(n, n_neighbors, coordx, coordy, coordz, diameters, ax, ay, az)
    diameters_fixed = MCS_functions.MCS_fix_diameters(tree_dist, tree_ind, diameters, n, n_neighbors, two_dimensions)
    clusters0, kanten0, newpoint10, newpoint20, temp1, temp2, list_dist0_full = MCS_functions.MCS_find_neighbors(n, n_neighbors, coordx, coordy, coordz, diameters_fixed, ax, ay, az)
    list_dist0 = MCS_functions.MCS_find_neighbors(n, 1, coordx, coordy, coordz, diameters_fixed, ax, ay, az, separation_list_only=True)
    #print list_dist
    #MCS_functions.calc_separation_distribution(list_dist,21)
    
#    job_restotal = numpy.zeros((n_deformation,3))
#    job_kLkT_restotal = numpy.zeros((n_deformation,2))
    job_restotal = []
    job_kLkT_restotal = []
    job_list_distL = {}
    job_list_distT = {}

    resistance0 = kanten0
    for i in range(numpy.shape(resistance0)[0]):
        resistance0[i,2] = MCS_functions.resistance_total(resistance0[i,2],a,b,c)
        
    # Total resistance of the network with Kirchhoff rules
    reslist0 = MCS_functions.build_listoftuples(resistance0)
    restotal0 = resistance.calculate_resistance_justsparse(n+2, reslist0, n, n+1)
    #print "LOOK: " + str(restotal0)
    
    n_deformation = len(deformation_array)
    job_restotal = numpy.zeros((n_deformation,3))
    job_kLkT_restotal = numpy.zeros((n_deformation,2))
    i_deformation = 0
    
    for deformation in deformation_array:
        clustersL, kantenL, newpoint1L, newpoint2L, temp1, temp2, list_distL_full = MCS_functions.MCS_find_neighbors(n, n_neighbors, coordx, coordy, coordz, diameters_fixed, ax, ay, az, E_ratio=E_ratio, xdeform=deformation)
        resistanceL = kantenL
        for i in range(numpy.shape(resistanceL)[0]):
            resistanceL[i,2] = MCS_functions.resistance_total(resistanceL[i,2],a,b,c)
        
        reslistL = MCS_functions.build_listoftuples(resistanceL)
        restotalL = resistance.calculate_resistance_justsparse(n+2, reslistL, n, n+1)
        
        clustersT, kantenT, newpoint1T, newpoint2T, temp1, temp2, list_distT_full = MCS_functions.MCS_find_neighbors(n, n_neighbors, coordx, coordy, coordz, diameters_fixed, ax, ay, az, E_ratio=E_ratio, ydeform=deformation)
        resistanceT = kantenT
        for i in range(numpy.shape(resistanceT)[0]):
            resistanceT[i,2] = MCS_functions.resistance_total(resistanceT[i,2],a,b,c)
        
        reslistT = MCS_functions.build_listoftuples(resistanceT)
        restotalT = resistance.calculate_resistance_justsparse(n+2, reslistT, n, n+1)
    
        kL_restotal = (restotalL-restotal0)/restotal0/(deformation-1.0)
        kT_restotal = (restotalT-restotal0)/restotal0/(deformation-1.0)
        
#        job_restotal = numpy.vstack((job_restotal,(restotal0,restotalL,restotalT)))
#        job_kLkT_restotal = numpy.vstack((job_kLkT_restotal,(kL_restotal,kT_restotal)))
        
        job_restotal[i_deformation,:] = (restotal0,restotalL,restotalT)
        job_kLkT_restotal[i_deformation,:] = (kL_restotal,kT_restotal)
        job_list_distL[i_deformation] = list_distL_full
        job_list_distT[i_deformation] = list_distT_full
        i_deformation += 1
        if visualize == True:
            break
        
    #if visualize==True:
    #        MCS_visualizations.MCS_call_model(deformation,ax,ay,az,coordx,coordy,coordz,diameters_fixed,clusters0,path0,clustersL,pathL,clustersT,pathT)

    if visualize==True:
        return (n, coordx, coordy, coordz, diameters_fixed, clusters0, clustersL, clustersT, job_restotal, job_kLkT_restotal, list_dist0)
    else:
        return (n, job_restotal, job_kLkT_restotal, list_dist0_full, job_list_distL, job_list_distT)
        
